import giambio


# A test for events


async def child(notifier: giambio.Event, pause: int):
    print("[child] Child is alive! Going to wait until notified")
    start_total = giambio.clock()
    await notifier.pause()
    end_pause = giambio.clock() - start_total
    print(f"[child] Parent set the event, exiting in {pause} seconds")
    start_sleep = giambio.clock()
    await giambio.sleep(pause)
    end_sleep = giambio.clock() - start_sleep
    end_total = giambio.clock() - start_total
    print(f"[child] Done! Slept for {end_total} seconds total ({end_pause} paused, {end_sleep} sleeping), nice nap!")


async def parent(pause: int = 1):
    event = giambio.Event()
    print("[parent] Spawning child task")
    task = giambio.spawn(child, event, pause + 2)
    start = giambio.clock()
    print(f"[parent] Sleeping {pause} second(s) before setting the event")
    await giambio.sleep(pause)
    await event.set()
    print("[parent] Event set, awaiting child")
    await task.join()
    end = giambio.clock() - start
    print(f"[parent] Child exited in {end} seconds")


if __name__ == "__main__":
    giambio.run(parent, 3)
